//+------------------------------------------------------------------+
//|                                                  AlligatorEx.mq4 |
//|                                                         Dizet_02 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Dizet_02"
#property link      ""

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
extern double StopLoss  =100;          // SL   
extern double TakeProfit=500;           //                            
extern double Lots      =0.1;          //   . 
extern double Prots     =0.07;
extern int    TrailingStop    = 10;      //= 0,   
extern int    TrailingStart   = 20;      //   0 
extern int    DeltaTrailing   = 5;       // -      
//-------------------------------------------------------------- 1a --

//-------------------------------------------------------------- 1b --
bool   Work=true;                      //   .
string Symb;                           //  . 
//--------------------------------------------------------------- 2 --
int start()
  {
   int
   Total,                              //     
   Tip=-1,                             //  .  (B=0,S=1)
   Ticket;                             //  
   double
   Lot,                                // .   .
   Lts,                                // .   .
   Min_Lot,                            //   
   Step,                               //    
   Free,                               //   
   One_Lot,                            //   
   Price, //   
   SL,
   TP;                              
   bool
   Ans  =false,                        //    
   Cls_B=false,                        //     Buy
   Cls_S=false,                        //     Sell
   Opn_B=false,                        //     Buy
   Opn_S=false;                        //     Sell
   
//--------------------------------------------------------------- 3 --
   // .
   if(Bars < 10)                       //  
     {
      Alert("   .   .");
      return;                                   //   start()
     }
   if(Work==false)                              //  
     {
      Alert(" .   .");
      return;                                   //   start()
     }
//--------------------------------------------------------------- 4 --
   //  
   Symb=Symbol();                               //  ..
   Total=0;                                     //  
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symb)continue;      //   . 
         if (OrderType()>1)                     //  
           {
            Alert("  .   .");
            return;                             //   start()
           }
         Total++;                               //  . 
         if (Total>1)                           //    
           {
            Alert("  .   .");
            return;                             //   start()
           }
         Ticket=OrderTicket();                  //  . .
         Tip   =OrderType();                    //   .
         Price =OrderOpenPrice();               //  . .
         Lot   =OrderLots();                    //  
         Profit();ChanceSLTP();
        }
     }
//--------------------------------------------------------------- 5 --
   //  
   
   //-------------------------------------------------------------- 5a --
   double jaw_op=iCustom(NULL, 0, "Alligator",13,8,8,5,5,3,0,-3);
   double teeth_op=iCustom(NULL, 0, "Alligator",13,8,8,5,5,3,0,1,-3);
   double lips_op=iCustom(NULL, 0, "Alligator",13,8,8,5,5,3,0,2,-3);
   double teeth_cl=iCustom(NULL, 0, "Alligator",13,8,8,5,5,3,0,1,-3);
   double lips_cl=iCustom(NULL, 0, "Alligator",13,8,8,5,5,3,0,2,-3);


//----------  ------------------------------ 5b --
   if (jaw_op>teeth_op && teeth_op>lips_op)
     {
      Opn_S=true;                              
     }
   if (jaw_op<teeth_op && teeth_op<lips_op)
     {
      Opn_B=true;                                    
     }
//--------------------------------------------------------------- 6 --
//----------  ---------------------------- 5b --
   if (teeth_cl>lips_cl)
     {      
      Cls_B=true;                    //  . Buy
     }
   if (teeth_cl<lips_cl)
     {      
      Cls_S=true;                    //  . Sell
     }
//--------------------------------------------------------------- 6 --
   //  
   while(true)                                  //   .
     {
      if (Tip==0 && Cls_B==true)                //   Buy..
        {                                       //   
         Alert("  Buy ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Bid,2);      //  Buy
         if (Ans==true)                         //  :)
           {
            Alert ("  Buy ",Ticket);
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }

      if (Tip==1 && Cls_S==true)                //   Sell..
        {                                       //    
         Alert("  Sell ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Ask,2);      //  Sell
         if (Ans==true)                         //  :)
           {
            Alert ("  Sell ",Ticket);
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     }
//--------------------------------------------------------------- 7 --
   //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   

   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  

   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   if (Lts*One_Lot > Free)                      //   .
     {
      Alert("     ", Lts," ");
      return;                                   //   start()
     }

//--------------------------------------------------------------- 8 --
   //  
   while(true)                                  //   .
     {
      if (Total==0 && Opn_B==true)              //  .  +
        {                                       //  . Buy
         RefreshRates();                        //  
         SL=Bid - New_Stop(StopLoss)*Point;     //  SL .
         TP=Bid + New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP);// Buy
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Buy ",Ticket);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      if (Total==0 && Opn_S==true)              //  .  +
        {                                       //  . Sell
         RefreshRates();                        //  
         SL=Ask + New_Stop(StopLoss)*Point;     //  SL .
         TP=Ask - New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Sell.  ..");
         Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,2,SL,TP);// Sell
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     }
//--------------------------------------------------------------- 9 --
   return;                                      //   start()
  }
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
  //-------------------------------------------------------------- 11 --
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// . 
   if (Parametr<Min_Dist)                       //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }
//-------------------------------------------------------------- 12 --
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
int Profit()
{ 
   int b,s;
   double  NULLPs,NULLPb,MargaSell,MargaBuy,price,price_b,price_s,lot,lot_s,lot_b;
   color TextColor;
   for (int i=0; i<OrdersTotal(); i++)
   {  if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {  if (OrderSymbol()==Symbol())
         {
            price = OrderOpenPrice();
            lot   = OrderLots();
            if (OrderType()==OP_BUY ) 
            {
               MargaBuy+=OrderProfit();
               price_b = price_b+price*lot; b++;  lot_b=lot_b+lot;
            }
            if (OrderType()==OP_SELL) 
            {
               MargaSell+=OrderProfit();
               price_s = price_s+price*lot; s++;  lot_s=lot_s+lot;
            }
   }  }  }
   ObjectDelete("NULLPb");
   if (b!=0) 
   {  NULLPb = NormalizeDouble(price_b/lot_b,Digits);
      ObjectCreate("NULLPb",OBJ_ARROW,0,Time[0],NULLPb,0,0,0,0);                     
      ObjectSet   ("NULLPb",OBJPROP_ARROWCODE,6);
      ObjectSet   ("NULLPb",OBJPROP_COLOR, Blue);
   }
   ObjectDelete("NULLPs");
   if (s!=0) 
   {  NULLPs = NormalizeDouble(price_s/lot_s,Digits);
   }
   if (MargaSell<0) TextColor=Red; else TextColor=Green;
   ObjectSetText("S",StringConcatenate("SELL  =",s);
   if (MargaBuy<0) TextColor=Red; else TextColor=Green;
   ObjectSetText("B",StringConcatenate("BUY   =",b);
}
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void ChanceSLTP()// C  
{  
   int STOPLEVEL,tip,Ticket;
   double OSL,OOP,OTP,NULLPs,NULLPb,TPb,SLb,TPs,SLs;
   STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL);
   if (NULLPb>0) TPb = NormalizeDouble(NULLPb + Point * TakeProfit,Digits);
   SLb = NormalizeDouble(Bid - Point * TrailingStop,Digits);
   if (NULLPs>0) TPs = NormalizeDouble(NULLPs - Point * TakeProfit,Digits);
   SLs = NormalizeDouble(Ask + Point * TrailingStop,Digits);
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS))
      {  tip = OrderType();
         if (OrderSymbol()==Symbol())
         {
            OSL   = NormalizeDouble(OrderStopLoss(),Digits);
            OTP   = NormalizeDouble(OrderTakeProfit(),Digits);
            OOP   = OrderOpenPrice();
            Ticket = OrderTicket();
            if (tip==0)             
            {
               if (TPb<=Ask+STOPLEVEL*Point || OTP==0) TPb=OTP;
               if (SLb>=Bid-STOPLEVEL*Point) SLb=OSL;
               if (SLb <(NULLPb+TrailingStart*Point)) SLb=OSL;
               if (SLb<(OSL+DeltaTrailing*Point))  SLb=OSL;
               if (OTP==TPb && OSL==SLb) continue;
               if (!OrderModify(Ticket,OOP,SLb,TPb,0,White)) 
                  Print(" OrderModify Buy ",OSL," -> ",SLb,"  ",OTP," -> ",TPb,"  ",GetLastError());
            }                                         
            if (tip==1)        
            {
               if (TPs>=Bid-STOPLEVEL*Point || OTP==0) TPs=OTP;
               if (SLs<=Ask+STOPLEVEL*Point) SLs=OSL;
               if (SLs > NULLPs-TrailingStart*Point)  SLs=OSL;
               if (SLs>OSL-DeltaTrailing*Point && OSL!=0)  SLs=OSL;
               if (OTP==TPs && OSL==SLs)  continue;
               if (!OrderModify(Ticket,OOP,SLs,TPs,0,White)) 
                  Print(" OrderModify Sell",OSL," -> ",SLs,"  ",OTP," -> ",TPs,"  ",GetLastError());
            } 
         }
      }
   }
}
//+------------------------------------------------------------------+